Index: graphics/wxWidgets-2.8/Portfile
===================================================================
--- graphics/wxWidgets-2.8/Portfile	(revision 146161)
+++ graphics/wxWidgets-2.8/Portfile	(working copy)
@@ -9,7 +9,7 @@
 
 name                wxWidgets-2.8
 version             2.8.12
-revision            2
+revision            3
 set branch          [join [lrange [split ${version} .] 0 1] .]
 set wxpythonsubset  wxPython-2.8.12.1-MacPorts-subset
 
@@ -69,10 +69,12 @@
                     port:libiconv \
                     port:expat
 
-depends_run         port:wxWidgets_select
+depends_run         port:wxWidgets-common\
+                    port:wxWidgets_select
 
+set selectdir       ${workpath}/select
 select.group        wxWidgets
-select.file         ${filespath}/${subport}
+select.file         ${selectdir}/${subport}
 
 archcheck.files     lib/libjpeg.dylib \
                     lib/libtiff.dylib \
@@ -92,6 +94,9 @@
 post-patch {
     reinplace "s|@@ARCHS@@|[get_canonical_archflags]|g" ${patch.dir}/configure
     reinplace "s|@@PREFIX@@|${prefix}|g"                ${patch.dir}/configure
+
+    file mkdir ${selectdir}
+    system "echo \"${wxWidgets.wxdir}/wx-config\n${wxWidgets.wxdir}/wxrc-${branch}\" > ${select.file}"
 }
 
 configure.cmd       ../configure
@@ -164,12 +169,8 @@
     # maybe not needed
     set confscript ${wxWidgets.prefix}/lib/wx/config/${wxtype}-unicode-${installtype}-${branch}
     ln -sf ${confscript} ${destroot}${wxWidgets.prefix}/bin/wx-config
-
-    xinstall -m 755 -d ${destroot}${prefix}/share/bakefile/presets
 }
 
-destroot.keepdirs ${destroot}${prefix}/share/bakefile/presets
-
 variant aui description {add support for AUI docking library} {
     configure.args-append    --enable-aui
 }
Index: graphics/wxWidgets-2.8/files/wxWidgets-2.8
===================================================================
--- graphics/wxWidgets-2.8/files/wxWidgets-2.8	(revision 146161)
+++ graphics/wxWidgets-2.8/files/wxWidgets-2.8	(nonexistent)
@@ -1,8 +0,0 @@
-${frameworks_dir}/wxWidgets.framework/Versions/wxWidgets/2.8/bin/wx-config
-${frameworks_dir}/wxWidgets.framework/Versions/wxWidgets/2.8/bin/wxrc-2.8
-${frameworks_dir}/wxWidgets.framework/Versions/wxWidgets/2.8/share/aclocal/wxwin.m4
-${frameworks_dir}/wxWidgets.framework/Versions/wxWidgets/2.8/share/bakefile/presets/wx.bkl
--
-${frameworks_dir}/wxWidgets.framework/Versions/wxWidgets/2.8/share/bakefile/presets/wx_unix.bkl
-${frameworks_dir}/wxWidgets.framework/Versions/wxWidgets/2.8/share/bakefile/presets/wx_win32.bkl
--
Index: graphics/wxWidgets-2.8/files/wxgtk-2.8
===================================================================
--- graphics/wxWidgets-2.8/files/wxgtk-2.8	(revision 146161)
+++ graphics/wxWidgets-2.8/files/wxgtk-2.8	(nonexistent)
@@ -1,8 +0,0 @@
-${frameworks_dir}/wxWidgets.framework/Versions/wxGTK/2.8/bin/wx-config
-${frameworks_dir}/wxWidgets.framework/Versions/wxGTK/2.8/bin/wxrc-2.8
-${frameworks_dir}/wxWidgets.framework/Versions/wxGTK/2.8/share/aclocal/wxwin.m4
-${frameworks_dir}/wxWidgets.framework/Versions/wxGTK/2.8/share/bakefile/presets/wx.bkl
--
-${frameworks_dir}/wxWidgets.framework/Versions/wxGTK/2.8/share/bakefile/presets/wx_unix.bkl
-${frameworks_dir}/wxWidgets.framework/Versions/wxGTK/2.8/share/bakefile/presets/wx_win32.bkl
--
Index: graphics/wxWidgets-3.0/Portfile
===================================================================
--- graphics/wxWidgets-3.0/Portfile	(revision 146161)
+++ graphics/wxWidgets-3.0/Portfile	(working copy)
@@ -11,7 +11,7 @@
 subport             wxPython-3.0 {}
 subport             wxgtk-3.0 {}
 version             3.0.2
-revision            3
+revision            4
 set wxpython_ver    3.0.2.0
 # when revbumping remember to change the revision also for wxPython-3.0
 
@@ -26,7 +26,7 @@
 } elseif {${subport} eq "wxPython-3.0"} {
     wxWidgets.use   wxPython-3.0
     version         3.0.2
-    revision        4
+    revision        5
 } elseif {${subport} eq "wxgtk-3.0"} {
     # with satisfactory Cocoa support there is no real need for GTK-based wxWidgets any more
     # wxgtk-3.0 is here mainly for testing purposes
@@ -79,10 +79,12 @@
     }
 }
 
-depends_run         port:wxWidgets_select
+depends_run         port:wxWidgets-common \
+                    port:wxWidgets_select
 
+set selectdir       ${workpath}/select
 select.group        wxWidgets
-select.file         ${filespath}/${subport}
+select.file         ${selectdir}/${subport}
 
 worksrcdir          ${distname}-${version}/build
 
@@ -94,6 +96,9 @@
 
 post-patch {
     reinplace "s|@@PREFIX@@|${prefix}|g" ${patch.dir}/configure
+
+    file mkdir ${selectdir}
+    system "echo \"${wxWidgets.wxdir}/wx-config\n${wxWidgets.wxdir}/wxrc-${branch}\" > ${select.file}"
 }
 
 configure.cmd       ../configure
@@ -201,11 +206,8 @@
 post-destroot {
     set confscript ${wxWidgets.prefix}/lib/wx/config/${wxtype}-unicode-${branch}
     ln -sf ${confscript} ${destroot}${wxWidgets.prefix}/bin/wx-config
-    xinstall -m 755 -d ${destroot}${prefix}/share/bakefile/presets
 }
 
-destroot.keepdirs ${destroot}${prefix}/share/bakefile/presets
-
 variant universal {
     set archs [join ${configure.universal_archs} ,]
     # --disable-precomp-headers is automatically selected with cocoa, but not with gtk
@@ -232,4 +234,4 @@
 
 livecheck.type      regex
 livecheck.url       ${homepage}/downloads/
-livecheck.regex     Release.*(\[23\]\\.\[0-9\]\\.\[0-9\]+)
+livecheck.regex     Release.*(3\\.0\\.\[0-9\]+)
Index: graphics/wxWidgets-3.0/files/wxPython-3.0
===================================================================
--- graphics/wxWidgets-3.0/files/wxPython-3.0	(revision 146161)
+++ graphics/wxWidgets-3.0/files/wxPython-3.0	(nonexistent)
@@ -1,8 +0,0 @@
-${frameworks_dir}/wxWidgets.framework/Versions/wxPython/3.0/bin/wx-config
-${frameworks_dir}/wxWidgets.framework/Versions/wxPython/3.0/bin/wxrc-3.0
-${frameworks_dir}/wxWidgets.framework/Versions/wxPython/3.0/share/aclocal/wxwin.m4
-${frameworks_dir}/wxWidgets.framework/Versions/wxPython/3.0/share/bakefile/presets/wx.bkl
-${frameworks_dir}/wxWidgets.framework/Versions/wxPython/3.0/share/bakefile/presets/wx_presets.py
-${frameworks_dir}/wxWidgets.framework/Versions/wxPython/3.0/share/bakefile/presets/wx_unix.bkl
-${frameworks_dir}/wxWidgets.framework/Versions/wxPython/3.0/share/bakefile/presets/wx_win32.bkl
-${frameworks_dir}/wxWidgets.framework/Versions/wxPython/3.0/share/bakefile/presets/wx_xrc.bkl
Index: graphics/wxWidgets-3.0/files/wxWidgets-3.0
===================================================================
--- graphics/wxWidgets-3.0/files/wxWidgets-3.0	(revision 146161)
+++ graphics/wxWidgets-3.0/files/wxWidgets-3.0	(nonexistent)
@@ -1,8 +0,0 @@
-${frameworks_dir}/wxWidgets.framework/Versions/wxWidgets/3.0/bin/wx-config
-${frameworks_dir}/wxWidgets.framework/Versions/wxWidgets/3.0/bin/wxrc-3.0
-${frameworks_dir}/wxWidgets.framework/Versions/wxWidgets/3.0/share/aclocal/wxwin.m4
-${frameworks_dir}/wxWidgets.framework/Versions/wxWidgets/3.0/share/bakefile/presets/wx.bkl
-${frameworks_dir}/wxWidgets.framework/Versions/wxWidgets/3.0/share/bakefile/presets/wx_presets.py
-${frameworks_dir}/wxWidgets.framework/Versions/wxWidgets/3.0/share/bakefile/presets/wx_unix.bkl
-${frameworks_dir}/wxWidgets.framework/Versions/wxWidgets/3.0/share/bakefile/presets/wx_win32.bkl
-${frameworks_dir}/wxWidgets.framework/Versions/wxWidgets/3.0/share/bakefile/presets/wx_xrc.bkl
Index: graphics/wxWidgets-3.0/files/wxWidgets-3.0-libcxx
===================================================================
--- graphics/wxWidgets-3.0/files/wxWidgets-3.0-libcxx	(revision 146161)
+++ graphics/wxWidgets-3.0/files/wxWidgets-3.0-libcxx	(nonexistent)
@@ -1,8 +0,0 @@
-${frameworks_dir}/wxWidgets.framework/Versions/wxWidgets/3.0-libcxx/bin/wx-config
-${frameworks_dir}/wxWidgets.framework/Versions/wxWidgets/3.0-libcxx/bin/wxrc-3.0
-${frameworks_dir}/wxWidgets.framework/Versions/wxWidgets/3.0-libcxx/share/aclocal/wxwin.m4
-${frameworks_dir}/wxWidgets.framework/Versions/wxWidgets/3.0-libcxx/share/bakefile/presets/wx.bkl
-${frameworks_dir}/wxWidgets.framework/Versions/wxWidgets/3.0-libcxx/share/bakefile/presets/wx_presets.py
-${frameworks_dir}/wxWidgets.framework/Versions/wxWidgets/3.0-libcxx/share/bakefile/presets/wx_unix.bkl
-${frameworks_dir}/wxWidgets.framework/Versions/wxWidgets/3.0-libcxx/share/bakefile/presets/wx_win32.bkl
-${frameworks_dir}/wxWidgets.framework/Versions/wxWidgets/3.0-libcxx/share/bakefile/presets/wx_xrc.bkl
Index: graphics/wxWidgets-3.0/files/wxgtk-3.0
===================================================================
--- graphics/wxWidgets-3.0/files/wxgtk-3.0	(revision 146161)
+++ graphics/wxWidgets-3.0/files/wxgtk-3.0	(nonexistent)
@@ -1,8 +0,0 @@
-${frameworks_dir}/wxWidgets.framework/Versions/wxGTK/3.0/bin/wx-config
-${frameworks_dir}/wxWidgets.framework/Versions/wxGTK/3.0/bin/wxrc-3.0
-${frameworks_dir}/wxWidgets.framework/Versions/wxGTK/3.0/share/aclocal/wxwin.m4
-${frameworks_dir}/wxWidgets.framework/Versions/wxGTK/3.0/share/bakefile/presets/wx.bkl
-${frameworks_dir}/wxWidgets.framework/Versions/wxGTK/3.0/share/bakefile/presets/wx_presets.py
-${frameworks_dir}/wxWidgets.framework/Versions/wxGTK/3.0/share/bakefile/presets/wx_unix.bkl
-${frameworks_dir}/wxWidgets.framework/Versions/wxGTK/3.0/share/bakefile/presets/wx_win32.bkl
-${frameworks_dir}/wxWidgets.framework/Versions/wxGTK/3.0/share/bakefile/presets/wx_xrc.bkl
Index: graphics/wxWidgets-common/Portfile
===================================================================
--- graphics/wxWidgets-common/Portfile	(nonexistent)
+++ graphics/wxWidgets-common/Portfile	(working copy)
@@ -0,0 +1,60 @@
+# -*- coding: utf-8; mode: tcl; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
+# $Id$
+
+PortSystem          1.0
+
+name                wxWidgets-common
+version             3.1.0
+
+categories          graphics devel
+platforms           darwin
+license             wxwidgets-3.1
+maintainers         mojca jwa openmaintainer
+
+master_sites        https://raw.githubusercontent.com/wxWidgets/wxWidgets/v${version}/:main \
+                    https://raw.githubusercontent.com/wxWidgets/wxWidgets/v${version}/build/bakefiles/wxpresets/presets/:bake
+
+# potentially more files in the future
+distfiles           wxwin.m4:main \
+                    wx.bkl:bake \
+                    wx_presets.py:bake \
+                    wx_unix.bkl:bake \
+                    wx_win32.bkl:bake \
+                    wx_xrc.bkl:bake \
+
+extract.only
+
+dist_subdir         wxWidgets/${version}
+
+checksums           wxwin.m4 \
+                    rmd160  efd174cb60fed37da1581cf226b68c236e60aa78 \
+                    sha256  f4d9a0bcdee2065956c7c1a928ac2c285fc8302d1d9423188006b17c36b1d535 \
+                    wx.bkl \
+                    rmd160  9f4bcff4a36b0f53039cdbb41978a2e6a2863d91 \
+                    sha256  59fe0a38c46f885412ce76e0a2959acf947d468db7332af2299713051f8392ad \
+                    wx_presets.py \
+                    rmd160  a640c4c7fc6f7568d3af4ff37a3f1bb7bb771024 \
+                    sha256  b306047d3668ddaf5c178f5dcf66342983bd564a5fa43a23997a837f3103aadb \
+                    wx_unix.bkl \
+                    rmd160  db4e42372ec0a73f76285eef4af7fdc10aa51e58 \
+                    sha256  8fdda613c2cbe7c2f8a9c213fc24227151c535efee4c1d85ff0a6b77bd0dc059 \
+                    wx_win32.bkl \
+                    rmd160  54a0405b68166aa6e2bc9c8bea70dffb6cda8285 \
+                    sha256  7514af88ed6882ee791f279c840810d5a98cc73b0397e969726b3fb631243cd5 \
+                    wx_xrc.bkl \
+                    rmd160  059754a4f42fca46e392bdae4aa8611b5c895232 \
+                    sha256  6d801e0d5759fbf4a06f07ffcc7defcbf2e1a5b241b36ac68cf44646efb829e8
+
+use_configure       no
+build {}
+
+destroot {
+    xinstall -m 755 -d ${destroot}${prefix}/share/aclocal
+    xinstall -m 755 -d ${destroot}${prefix}/share/bakefile/presets
+    xinstall -m 644 ${distpath}/wxwin.m4 ${destroot}${prefix}/share/aclocal
+    foreach f {wx.bkl wx_presets.py wx_unix.bkl wx_win32.bkl wx_xrc.bkl} {
+        xinstall -m 644 ${distpath}/${f} ${destroot}${prefix}/share/bakefile/presets
+    }
+}
+
+# TODO: pre-activate step to clean up any remainings/leftovers

Property changes on: graphics/wxWidgets-common/Portfile
___________________________________________________________________
Added: svn:eol-style
## -0,0 +1 ##
+native
\ No newline at end of property
Added: svn:keywords
## -0,0 +1 ##
+Id
\ No newline at end of property
Index: sysutils/wxWidgets_select/Portfile
===================================================================
--- sysutils/wxWidgets_select/Portfile	(revision 146161)
+++ sysutils/wxWidgets_select/Portfile	(working copy)
@@ -7,6 +7,7 @@
 
 name                wxWidgets_select
 version             1.0
+revision            1
 categories          sysutils graphics
 platforms           darwin
 maintainers         nomaintainer
Index: sysutils/wxWidgets_select/files/base
===================================================================
--- sysutils/wxWidgets_select/files/base	(revision 146161)
+++ sysutils/wxWidgets_select/files/base	(working copy)
@@ -1,8 +1,2 @@
 bin/wx-config
 bin/wxrc
-share/aclocal/wxwin.m4
-share/bakefile/presets/wx.bkl
-share/bakefile/presets/wx_presets.py
-share/bakefile/presets/wx_unix.bkl
-share/bakefile/presets/wx_win32.bkl
-share/bakefile/presets/wx_xrc.bkl
Index: sysutils/wxWidgets_select/files/none
===================================================================
--- sysutils/wxWidgets_select/files/none	(revision 146161)
+++ sysutils/wxWidgets_select/files/none	(working copy)
@@ -1,8 +1,2 @@
 -
 -
--
--
--
--
--
--