--- Portfile.orig	2015-11-20 22:01:12.000000000 +0100
+++ Portfile	2016-05-16 13:11:56.000000000 +0200
@@ -21,22 +21,14 @@
     long_description    ${description}: \
         This port is kept up with the VOLK-GNSS-SDR release, which is typically updated every few months. This version compiles against the gnss-sdr and gnuradio ports.
 
-    github.setup        gnss-sdr gnss-sdr 0.0.6 v
-    revision            2
-    checksums           rmd160 3a578f4795f6230d3f627dbe6f80f77c7dac206e \
-                        sha256 ed81a5dff8d91b0b1d561ab8a240818da447c8358b95ab42d6a17b479e873c3e
+    github.setup        gnss-sdr gnss-sdr 0.0.7 v
+    revision            1
+    checksums           rmd160 c9bee1c541979d2ae573ae63848051354ef3f68f \
+                        sha256 3b25a45c6faa48017176858c2673a1301ead3b4cf7cdc52bdfad3e05669e90ae
     github.tarball_from tags
 
     conflicts           volk-gnss-sdr-devel volk-gnss-sdr-next
 
-    # temporary patch to fix Volk #define in compatibility
-
-    patchfiles-append   patch-volk-include.release.diff
-
-    # temporary patch to fix name of Volk-Gnss-Sdr cmake file
-
-    patchfiles-append   patch-Volk_GnssSdrConfig.cmake.release.diff
-
 }
 
 subport volk-gnss-sdr-devel {
@@ -45,17 +37,13 @@
         This port is kept up with the VOLK-GNSS-SDR GIT master branch, which is typically updated daily to weekly.  This version of VOLK-GNSS-SDR generally contains fixes and new features that will be incorporated in an upcoming release, and compiles against the gnss-sdr-devel and gnuradio-devel ports.  This port may or not compile or function correctly, as it represents a work in progress.  If it does not work, check back in a few days.  Or try deactivating the currently active gnss-sdr and gnuradio ports, cleaning any current builds, and trying again.
 
     name                volk-gnss-sdr-devel
-    github.setup        gnss-sdr gnss-sdr 8838e9063e7479c1c6339e0d012724d269e8d000
-    version             20151103
-    checksums           rmd160 fc6e6a176c97dc1a0a3072e28accb37b0d301999 \
-                        sha256 42337ac6a79f0bee33fbc8f5eb4ab586346050ae9873046a4b6e415bce0eb20e
+    github.setup        gnss-sdr gnss-sdr a6df9f8c6f4c5665976cfa70e844ce1b56ac7323
+    version             20160516
+    checksums           rmd160 c9bee1c541979d2ae573ae63848051354ef3f68f \
+                        sha256 3b25a45c6faa48017176858c2673a1301ead3b4cf7cdc52bdfad3e05669e90ae
 
     conflicts           volk-gnss-sdr volk-gnss-sdr-next
 
-    # temporary patch to fix name of Volk-Gnss-Sdr cmake file
-
-    patchfiles-append   patch-Volk_GnssSdrConfig.cmake.devel.diff
-
 }
 
 subport volk-gnss-sdr-next {
@@ -63,17 +51,13 @@
         This port is kept up with the VOLK-GNSS-SDR GIT next branch, which is typically updated daily to weekly.  This version of VOLK-GNSS-SDR generally contains fixes and new features that will be incorporated in an upcoming release, and compiles against the gnss-sdr-next and gnuradio-next ports.  This port may or not compile or function correctly, as it represents a work in progress.  If it does not work, check back in a few days.  Or try deactivating the currently active gnss-sdr and gnuradio ports, cleaning any current builds, and trying again.
 
     name                volk-gnss-sdr-next
-    github.setup        gnss-sdr gnss-sdr 8abe0486e9ef43e3082b66932a0b7e5018582027
-    version             20151103
-    checksums           rmd160 2769b23825b180c095493702990dbf77ecacf97b \
-                        sha256 f353f9a9e6061e5798217db832dc1f70b360597be1e7e8e3f7f9470264b278c9
+    github.setup        gnss-sdr gnss-sdr 51e9a3434da85547a7860d298fcc5c180e390f19
+    version             20160516
+    checksums           rmd160 ea87a5cc389ab366248a84131991396e3cfc815d \
+                        sha256 644a19b780ad3004fbe34924f0fb422b48febf565babc3c9f088192049bf3bc6
 
     conflicts           volk-gnss-sdr volk-gnss-sdr-devel
 
-    # temporary patch to fix name of Volk-Gnss-Sdr cmake file
-
-    patchfiles-append   patch-Volk_GnssSdrConfig.cmake.next.diff
-
 }
 
 # override githib PortGroup homepage setting