--- Portfile~	2016-07-08 23:30:07.000000000 -0600
+++ Portfile	2016-08-29 11:24:35.000000000 -0600
@@ -5,10 +5,10 @@
 PortGroup           perl5 1.0
 PortGroup           github 1.0
 
-set perl-version    5.22
+set perl-version    5.24
 perl5.branches      ${perl-version}
 
-github.setup        bruceravel demeter 0.9.24
+github.setup        bruceravel demeter 0.9.25
 
 conflicts           demeter-devel
 
@@ -23,18 +23,15 @@
 
 homepage            http://bruceravel.github.io/demeter/
 
-checksums           rmd160  d8742b7b6c3c281ce3861e0ac0170b0201bf68c7 \
-                    sha256  a8ee4de5974f293ba7a52ae418934e88cd4345dcea6f36005b41ec1fb36e5f02
+checksums           rmd160  be2d1eeec4e698d8630cf910a141640503ec5777 \
+                    sha256  54801aa04d8e8f83ea3ecf52024eb75d34410c29c0188c8be8917f09bcd6efd2
 
 depends_build-append \
+                    port:p${perl-version}-capture_tiny \
+                    port:p${perl-version}-file-copy-recursive \
                     port:p${perl-version}-file-touch \
                     port:p${perl-version}-file-slurper \
-                    port:p${perl-version}-image-size \
-                    port:p${perl-version}-pod-projectdocs \
-                    port:p${perl-version}-ppi \
-                    port:p${perl-version}-ppi-html \
-                    port:p${perl-version}-syntax-highlight-perl \
-                    port:p${perl-version}-template-toolkit
+                    port:p${perl-version}-pod-projectdocs
 
 depends_lib-append  port:ifeffit \
                     port:p${perl-version}-archive-zip \
@@ -61,14 +58,11 @@
                     port:p${perl-version}-math-spline \
                     port:p${perl-version}-moose \
                     port:p${perl-version}-moosex-aliases \
-                    port:p${perl-version}-moosex-singleton \
-                    port:p${perl-version}-moosex-strictconstructor \
                     port:p${perl-version}-moosex-types \
                     port:p${perl-version}-moosex-types-laxnum \
                     port:p${perl-version}-pdl \
                     port:p${perl-version}-pdl-stats \
                     port:p${perl-version}-pod-pom \
-                    port:p${perl-version}-ppi \
                     port:p${perl-version}-regexp-assemble \
                     port:p${perl-version}-regexp-common \
                     port:p${perl-version}-soap-lite \
@@ -78,6 +72,7 @@
                     port:p${perl-version}-term-sk \
                     port:p${perl-version}-term-twiddle \
                     port:p${perl-version}-text-template \
+                    port:p${perl-version}-text-unidecode \
                     port:p${perl-version}-tree-simple \
                     port:p${perl-version}-want \
                     port:p${perl-version}-wx \
@@ -85,17 +80,6 @@
                     port:p${perl-version}-yaml-tiny \
                     port:perl${perl-version}
 
-patchfiles          patch-DocBuilder-Artemis.pm.diff \
-                    patch-DocBuilder-Athena.pm.diff
-
-post-patch {
-    reinplace "s|@@PERL-VERSION@@|${perl-version}|g" ${worksrcpath}/DocBuilder/Artemis.pm
-    reinplace "s|@@PERL-VERSION@@|${perl-version}|g" ${worksrcpath}/DocBuilder/Athena.pm
-
-    # File::Find can't handle recursive links - t@ -> .
-    file delete ${worksrcpath}/t/t
-}
-
 configure.cmd       ${prefix}/bin/perl${perl-version} Build.PL
 configure.args      --destdir ${destroot}
 
@@ -106,7 +90,6 @@
     # Put the main executables (perl scripts) into the PATH
     ln -s ${prefix}/libexec/perl${perl-version}/sitebin/dartemis    ${destroot}${prefix}/bin/artemis
     ln -s ${prefix}/libexec/perl${perl-version}/sitebin/dathena     ${destroot}${prefix}/bin/athena
-    ln -s ${prefix}/libexec/perl${perl-version}/sitebin/atoms-gui   ${destroot}${prefix}/bin/atoms
     ln -s ${prefix}/libexec/perl${perl-version}/sitebin/datoms      ${destroot}${prefix}/bin/datoms
     ln -s ${prefix}/libexec/perl${perl-version}/sitebin/dhephaestus ${destroot}${prefix}/bin/hephaestus
 }
@@ -115,13 +98,13 @@
 
 # At the moment, demeter-devel will use the most recent full release
 subport demeter-devel {
-    github.setup        bruceravel demeter 0.9.24
+    github.setup        bruceravel demeter 0.9.25
     epoch               2
 
     conflicts           demeter
 
-checksums           rmd160  d8742b7b6c3c281ce3861e0ac0170b0201bf68c7 \
-                    sha256  a8ee4de5974f293ba7a52ae418934e88cd4345dcea6f36005b41ec1fb36e5f02
+checksums           rmd160  be2d1eeec4e698d8630cf910a141640503ec5777 \
+                    sha256  54801aa04d8e8f83ea3ecf52024eb75d34410c29c0188c8be8917f09bcd6efd2
 
 #    depends_lib-append  port:p${perl-version}-encoding-fixlatin-xs
 }